using System;
using System.Collections.Generic;
using Avalonia.Controls.Shapes;
using Avalonia.Controls;
using Avalonia.Media;
using Avalonia.Threading;
using Avalonia;
using System.Drawing.Drawing2D;
using ReactiveUI;
using Calculator.Models;

namespace Calculator.ViewModels
{
	public class LoginViewModel : ReactiveObject
	{
        DispatcherTimer timer = new DispatcherTimer();

        #region   
        private bool _enable = true;

        public bool Enable
        {
            get { return _enable; }
            set => this.RaiseAndSetIfChanged(ref _enable, value);
        }


        private string _captext;

        public string CapText
        {
            get { return _captext; }
            set => this.RaiseAndSetIfChanged(ref _captext, value);
        }


        private Canvas _capcha;

        public Canvas Capcha
        {
            get { return _capcha; }
            set => this.RaiseAndSetIfChanged(ref _capcha, value);
        }

        private bool _visibility = false;

        public bool Visibility
        {
            get { return _visibility; }
            set => this.RaiseAndSetIfChanged(ref _visibility, value);
        }


        private string _login;

        public string GetSetLogin
        {
            get { return _login; }
            set => this.RaiseAndSetIfChanged(ref _login, value);
        }

        private string _pass;

        public string GetSetPass
        {
            get { return _pass; }
            set => this.RaiseAndSetIfChanged(ref _pass, value);
        }
        #endregion

        public bool LogIn()
        {
            if (!Visibility)
            {
                if (_login == LogData.LoginData && _pass == LogData.Password)
                {
                    return true;
                }
                else
                {
                    Visibility = true;
                    CreateCap();
                    return false;
                }
            }
            else
            {
                if (_login == LogData.LoginData && _pass == LogData.Password && _captext.ToUpper() == LogData.Capcha)
                {
                    return true;
                }
                else
                {
                    GetSetLogin = "";
                    GetSetPass = "";
                    CapText = "";
                    Enable = false;
                    Visibility = false;
                    timer.Tick += new EventHandler(Unblock);
                    timer.Interval = new TimeSpan(0, 0, 10);
                    timer.Start();
                    return false;
                }
            }
        }

        private void Unblock(object? sender, EventArgs e)
        {
            Enable = true;
            Visibility = true;
        }

        public void CreateCap()
        {
            LogData.Capcha = "";
            SolidColorBrush color = new SolidColorBrush(Colors.Yellow);
            Canvas canava = new Canvas()
            {
                Width = 200,
                Height = 200,
                Background = color,
                Margin = new Thickness(0, 10, 0, 0)
            };
            Random r = new Random();
            int fs;
            Avalonia.Media.FontStyle fontStyle = Avalonia.Media.FontStyle.Normal;
            FontWeight fontWeight = FontWeight.Normal;
            for (int i = 1; i <= 10; i++)
            {
                fs = r.Next(1, 3);
                if (fs == 1)
                {
                    fontStyle = Avalonia.Media.FontStyle.Oblique;
                }
                if (fs == 2)
                {
                    fontWeight = FontWeight.Bold;
                }
                if (fs == 3)
                {
                    fontWeight = FontWeight.Bold;
                    fontStyle = Avalonia.Media.FontStyle.Italic;
                }
                TextBlock tb = new TextBlock()
                {
                    Padding = new Thickness(i * 19, r.Next(100), 0, r.Next(100)),
                    Foreground = new SolidColorBrush(Colors.LimeGreen),
                    FontStyle = fontStyle,
                    FontWeight = fontWeight
                };
                if (i % 2 == 0)
                {
                    tb.Text = Convert.ToString((char)r.Next(65, 90));
                }
                else
                {
                    tb.Text = Convert.ToString(r.Next(1, 9));
                }
                LogData.Capcha += tb.Text;
                canava.Children.Add(tb);
                Line line = new Line()
                {
                    StartPoint = new Avalonia.Point(r.Next(200), r.Next(200)),
                    EndPoint = new Avalonia.Point(r.Next(200), r.Next(200)),
                    Stroke = Avalonia.Media.Brushes.Red,
                    StrokeThickness = 3
                };
                canava.Children.Add(line);
            }

            Capcha = canava;
        }
    }
}